﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Data.Objects;
using System.Web.Script.Serialization;

namespace mobx.mobi.DAL
{
    public static class Extensions
    {
        /// <summary>
        /// Determines whether record is attached
        /// </summary>
        /// <param name="context">Context</param>
        /// <param name="entity">Entity</param>
        /// <returns>Result</returns>
        public static bool IsAttached(this MbDataEntities context, object entity)
        {
            if (entity == null)
            {
                throw new ArgumentNullException("entity");
            }
            ObjectStateEntry entry;
            try
            {
                entry = context.ObjectStateManager.GetObjectStateEntry(entity);
                return (entry.State != EntityState.Detached);
            }
            catch (Exception exc)
            {
                Debug.WriteLine(exc.ToString());
            }
            return false;
        }


        public static T GetContent<T>(this MbPage obj) where T : class
        {
            if (obj != null &&
                !string.IsNullOrEmpty(obj.PageContent))
            {
                JavaScriptSerializer serializer = new JavaScriptSerializer();
                T type = serializer.Deserialize<T>(obj.PageContent);
                return type;
            }
            return null;
        }

        public static void SetContent(this MbPage page, object T)
        {
            if (T != null)
            {
                JavaScriptSerializer serializer = new JavaScriptSerializer();
                string json = serializer.Serialize(T);
                page.PageContent = json;
            }
        }
    }
}
