﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace mobx.mobi.DAL.Managers
{
    public class SettingManager
    {
        public SettingManager()
        {
            
        }

        public MbSetting GetSetting(string settingName)
        {
            MbSetting setting = null;
            if (!string.IsNullOrEmpty(settingName) && 
                Singleton.DB != null)
            {
                try
                {
                    setting = Singleton.DB.MbSettings.Where(s => s.Name.ToLower() == settingName.ToLower()).FirstOrDefault();
                }
                catch
                {
                    //ignore
                }
            }
            return setting;
        }
        public string GetSettingValue(string settingName)
        {
            string result = null;
            MbSetting setting = GetSetting(settingName);
            if (setting != null)
            {
                result = setting.Value;
            }
            return result;
        }
        public bool GetSettingValueBool(string settingName)
        {
            bool result = false;
            string settingStr = GetSettingValue(settingName);
            if (!string.IsNullOrEmpty(settingStr))
            {
                bool parseSuccess = Boolean.TryParse(settingStr, out result);
                if (!parseSuccess)
                {
                    result = false;
                }
            }
            return result;
        }
        public int GetSettingValueInt(string settingName)
        {
            int result = 0;
            string settingStr = GetSettingValue(settingName);
            if (!string.IsNullOrEmpty(settingStr))
            {
                bool parseSuccess = Int32.TryParse(settingStr, out result);
                if (!parseSuccess)
                {
                    result = 0;
                }
            }
            return result;
        }
        public MbSetting UpsertSetting(string settingName, string settingValue, string settingDescription)
        {
            MbSetting mbSetting = null;
            try
            {
                if (!string.IsNullOrEmpty(settingName))
                {
                    mbSetting = GetSetting(settingName);
                    if (mbSetting != null)
                    {
                        if (settingValue == null)
                            settingValue = string.Empty;
                        mbSetting.Value = settingValue;
                        mbSetting.Description = settingDescription;
                        Singleton.DB.SaveChanges();
                    }
                    else
                    {
                        mbSetting = new MbSetting
                        {
                            Description = settingDescription,
                            Name = settingName,
                            Value = settingValue
                        };
                        Singleton.DB.MbSettings.AddObject(mbSetting);
                        Singleton.DB.SaveChanges();
                    }
                }
            }
            catch
            {
                mbSetting = null;
            }
            return mbSetting;
        }
        public string GetTheme()
        {
            string theme = GetSettingValue("Theme");
            if (string.IsNullOrEmpty(theme))
                theme = "b";
            return theme;
        }
        public string GetTransition()
        {
            string theme = GetSettingValue("Transition");
            if (string.IsNullOrEmpty(theme))
                theme = "slide";
            return theme;
        }
        public string GetGoogleAnalytics()
        {
            string ga = GetSettingValue("GA");
            if (ga == null)
                ga = string.Empty;
            return ga;
        }
        public int GetDefaultPageId()
        {
            int defaultPageId = GetSettingValueInt("DefaultPageId");
            return defaultPageId;
        }
    }
}
