﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace mobx.mobi.DAL.Managers
{
    public class UserManager
    {
        public UserManager()
        {
        }

        public MbUser GetUserByEmail(string email)
        {
            MbUser user = null;
            if (!string.IsNullOrEmpty(email))
            {
                email = email.ToLower().Trim();
                user = Singleton.DB.MbUsers.Where(u => u.Email == email).FirstOrDefault();
            }
            return user;
        }

        public MbUser AddUser(string email, string passwordHash, string passwordSalt, DateTime registrationDate, bool active, bool deleted, bool isAdmin, Guid userGuid)
        {
            MbUser mbUser = new MbUser
            {
                Email = email,
                PasswordHash = passwordHash,
                PasswordSalt = passwordSalt,
                RegistrationDate = registrationDate,
                Active = active,
                Deleted = deleted,
                UserGUID = userGuid,
                //UserId = ,
            };
            return AddUser(mbUser);
        }

        public MbUser AddUser(MbUser mbUser)
        {
            Singleton.DB.MbUsers.AddObject(mbUser);
            Singleton.DB.SaveChanges();
            return mbUser;
        }

        public MbUser UpdateUser(MbUser mbUser)
        {
            if (!Singleton.DB.IsAttached(mbUser))
                Singleton.DB.MbUsers.Attach(mbUser);
            Singleton.DB.SaveChanges();
            return mbUser;
        }  
    }
}
