﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace mobx.mobi.DAL
{
    public class MbPageMetadata
    {
        #region Primitive Properties
        [DisplayName("Page ID")]
        [Required(ErrorMessage="Page ID is required"), Range(-1, Int32.MaxValue, ErrorMessage = "Page ID must be a positive number")]
        public int PageId
        {
            get;
            set;
        }

        [DisplayName("Url Name")]
        [Required(ErrorMessage="Url name is required"), StringLength(255)]
        [RegularExpression(@"^[a-zA-Z0-9]+$", ErrorMessage = "Only English letters are allowed.")]
        public string Alias
        {
            get;
            set;
        }

        [DisplayName("Meta Description")]
        [StringLength(1000)]
        public string MetaDescription
        {
            get;
            set;
        }

        [DisplayName("Meta Keywords")]
        [StringLength(1000)]
        public string MetaKeywords
        {
            get;
            set;
        }

        [DisplayName("Title")]
        [Required(ErrorMessage = "Title is required"), StringLength(100)]
        public string Title
        {
            get;
            set;
        }

        [DisplayName("Content")]
        public string PageContent
        {
            get;
            set;
        }

        public bool Published
        {
            get;
            set;
        }

        public string PageType
        {
            get;
            set;
        }
        #endregion
    }
}
