﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Configuration;
using mobx.mobi.Core;

namespace mobx.mobi.DAL
{
    public class Singleton
    {
        public static MbDataEntities DB
        {
            get
            {
                if (HttpContext.Current.Items["MbEntitiesSingleton"] == null)
                {
                    if (ConnectionString != null)
                    {
                        HttpContext.Current.Items["MbEntitiesSingleton"] = new MbDataEntities(ConnectionString);
                    }
                    else
                    {
                        return null;
                    }
                }
                return (MbDataEntities)HttpContext.Current.Items["MbEntitiesSingleton"];
            }
           
        }

        private static string _connectionString;
        /// <summary>
        /// Entity framework format connection string
        /// </summary>
        public static string ConnectionString
        {
            get
            {
                if (!string.IsNullOrEmpty(_connectionString))
                    return _connectionString;

                string sqlProviderConnString = CoreCommon.GetConnectionString();
                if (!string.IsNullOrEmpty(sqlProviderConnString))
                    _connectionString = CoreCommon.CreateEFConnectionString(sqlProviderConnString);
                return _connectionString;
            } 
            set
            {
                _connectionString = value;
            }
        }
    }
}
