﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Reflection;
using mobx.mobi.Core;
using mobx.mobi.DAL;
using mobx.mobi.DAL.Managers;

namespace mobx.mobi.Areas.Admin.Controllers
{ 
    public class DefaultController : Controller
    {
        private List<PageAttribute> GetAvailablePages()
        {
            Type typeICmsPage = typeof(mobx.mobi.Core.ICmsPage);
            Type[] executingTypes = Assembly.GetExecutingAssembly().GetTypes();
            List<PageAttribute> availPages = new List<PageAttribute>();
            if (executingTypes != null &&
                executingTypes.Length > 0)
            {
                foreach (Type t in executingTypes)
                {
                    if (typeICmsPage.IsAssignableFrom(t))
                    {
                        PageAttribute attr = CoreCommon.GetClassAttribute<mobx.mobi.Core.PageAttribute>(t);
                        availPages.Add(attr);
                    }
                }
            }
            return availPages;
        }

        //
        // GET: /Admin/Default/
        [Authorize]
        public ViewResult Index()
        {
            PageManager pageManager = new PageManager();
            List<MbPage> sitePages = pageManager.GetPages(false);
            return View(sitePages);
        }

        [Authorize]
        public ActionResult Add(string id)
        {
            if (string.IsNullOrEmpty(id))
            {
                List<PageAttribute> availPages = GetAvailablePages();
                return View(availPages);
            }
            else
            {
                string controllerName = MbCommon.ParseControllerName(id);
                if (!string.IsNullOrEmpty(controllerName))
                {
                    return RedirectToAction("Create", controllerName);
                }
            }
            return View("Index");
        }
    }
}