﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using mobx.mobi.Areas.Admin.Models;
using System.Web.Mvc.Html;
using mobx.mobi.DAL.Managers;
using mobx.mobi.DAL;

namespace mobx.mobi.Areas.Admin.Controllers
{
    public class MenuController : Controller
    {
        //
        // GET: /Admin/Menu/
        [Authorize]
        public ActionResult Index()
        {
            return View();
        }

        [Authorize]
        public ActionResult Add()
        {
            MbMenu menu = new MbMenu
            {
                MenuId = 0,
                SortOrder = 1
            };
            return View(menu);
        }

        [Authorize]
        [HttpPost]
        public ActionResult Add(MbMenu model)
        {
            if (ModelState.IsValid)
            {
                MenuManager menuMan = new MenuManager();
                MbMenu menu = menuMan.AddMenu(model.LinkToPageId, model.LinkText, model.LinkUrl);
                if (menu != null)
                    return RedirectToAction("Index", "Menu");
                else
                    ModelState.AddModelError("", "Some fields are missing");
            }
            return View(model);
        }

        [Authorize]
        [HttpPost]
        public ActionResult Delete(MbMenu model)
        {
            MenuManager menuMan = new MenuManager();
            menuMan.DeleteMenu(model.MenuId);
            return RedirectToAction("Index", "Menu");
        }

        [Authorize]
        [HttpPost]
        public ActionResult ShiftUp(MbMenu model)
        {
            MenuManager menuMan = new MenuManager();
            menuMan.ShiftUp(model.MenuId);
            return Content("");
        }

        [Authorize]
        [HttpPost]
        public ActionResult ShiftDown(MbMenu model)
        {
            MenuManager menuMan = new MenuManager();
            menuMan.ShiftDown(model.MenuId);
            return Content("");
        }
    }
}