﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using mobx.mobi.Areas.Admin.Models;
using System.Web.Mvc.Html;
using mobx.mobi.DAL.Managers;

namespace mobx.mobi.Areas.Admin.Controllers
{
    public class SettingsController : Controller
    {
        //
        // GET: /Admin/Settings/
        [Authorize]
        public ActionResult Index()
        {
            SettingsModel model = new SettingsModel();
            SettingManager settingMan = new SettingManager();
            model.Theme = settingMan.GetTheme();
            model.Transition = settingMan.GetTransition();
            model.GoogleAnalytics = settingMan.GetGoogleAnalytics();
            if (string.IsNullOrEmpty(model.GoogleAnalytics))
            {
                model.GoogleAnalytics = null;
            }
            model.DefaultPageId = settingMan.GetDefaultPageId();
            return View(model);
        }

        [Authorize]
        [HttpPost]
        public ActionResult Index(SettingsModel model)
        {
            if (ModelState.IsValid)
            {
                SettingManager settingMan = new SettingManager();
                settingMan.UpsertSetting("Theme", model.Theme, null);
                settingMan.UpsertSetting("Transition", model.Transition, null);
                settingMan.UpsertSetting("GoogleAnalytics", model.GoogleAnalytics, null);
                settingMan.UpsertSetting("DefaultPageId", (model.DefaultPageId > 0 ? model.DefaultPageId.ToString() : null), null);
                return RedirectToAction("Index", "Default");
            }
            return View(model);
        }
    }
}
