﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using mobx.mobi.DAL;
using System.Web.Script.Serialization;

namespace mobx.mobi.Areas.Admin.Models
{
    public class ContactFormModel : ContactFormBase, IMbPage
    {
        public ContactFormModel()
        {

        }

        public ContactFormModel(MbPage mbpage)
        {
            if (mbpage != null)
            {
                this.CurrentPage = mbpage;
                if (!string.IsNullOrEmpty(mbpage.PageContent))
                {
                    ContactFormBase contactBase = mbpage.GetContent<ContactFormBase>();
                    this.Email = contactBase.Email;
                    this.SMS = contactBase.SMS;
                    this.Tel = contactBase.Tel;
                    this.ShowContactForm = contactBase.ShowContactForm;
                    this.Address = contactBase.Address;
                    this.City = contactBase.City;
                    this.State = contactBase.State;
                    this.Country = contactBase.Country;
                }
            }
        }

        public MbPage CurrentPage { get; set; }

        public ContactFormBase ToBase()
        {
            return new ContactFormBase
                    {
                        Email = this.Email,
                        SMS = this.SMS,
                        Tel = this.Tel,
                        ShowContactForm = this.ShowContactForm,
                        Address = this.Address,
                        City = this.City,
                        State = this.State,
                        Country = this.Country
                    };
        }
    }
}