﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using mobx.mobi.DAL;
using System.Web.Script.Serialization;

namespace mobx.mobi.Areas.Admin.Models
{
    public class ImageWithTextModel : ImageWithTextBase, IMbPage
    {
        public ImageWithTextModel()
        {

        }

        public ImageWithTextModel(MbPage mbpage)
        {
            if (mbpage != null)
            {
                this.CurrentPage = mbpage;
                if (!string.IsNullOrEmpty(mbpage.PageContent))
                {
                    ImageWithTextBase modelBase = mbpage.GetContent<ImageWithTextBase>();
                    this.Heading = modelBase.Heading;
                    this.Text = modelBase.Text;
                    this.ImageUrl = modelBase.ImageUrl;                   
                }
            }
        }

        public MbPage CurrentPage { get; set; }

        public ImageWithTextBase ToBase()
        {
            return new ImageWithTextBase
                    {
                        Heading = this.Heading,
                        Text = this.Text,
                        ImageUrl = this.ImageUrl
                    };
        }
    }
}