﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Mail;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using mobx.mobi.DAL;
using mobx.mobi.DAL.Managers;
using mobx.mobi.Models;
using System.Text;
using System.Net.Configuration;
using System.Web.Configuration;
using System.Configuration;

namespace mobx.mobi.Controllers
{
    public class ContactFormController : Controller
    {
        //
        // GET: /Contact/
        public ActionResult Index()
        {
            mobx.mobi.Models.ContactFormModel model = GetCurrentModel();
            return View(model);
        }

        private ContactFormModel GetCurrentModel()
        {
            string pageAlias = MbCommon.CurrentPageAlias;
            PageManager pageManager = new PageManager();
            MbPage page = pageManager.GetPage(pageAlias);
            mobx.mobi.Models.ContactFormModel model = null;
            if (page != null)
            {
                model = new ContactFormModel(page);
            }
            return model;
        }

        [HttpPost]
        public ActionResult Index(ContactFormModel model)
        {
            try
            {
                var curModel = GetCurrentModel();
                if (ModelState.IsValid &&
                    model != null &&
                    !string.IsNullOrEmpty(model.EmailBody) &&
                    curModel != null &&
                    !string.IsNullOrEmpty(curModel.Email))
                {
                    //send email
                    string subject = model.EmailSubject;
                    string body = "Name:" + model.VisitorName + "<br/>Email:" + model.VisitorEmail + "<br/>Subject:" + model.EmailSubject + "<br/>Message:" + model.EmailBody;
                    MailAddress visitorAddress = new MailAddress(model.VisitorEmail, model.VisitorName);

                    Configuration config = WebConfigurationManager.OpenWebConfiguration(HttpContext.Request.ApplicationPath);
                    MailSettingsSectionGroup settings = (MailSettingsSectionGroup)config.GetSectionGroup("system.net/mailSettings");
                    MailAddress from = new MailAddress(settings.Smtp.From);
                    MailAddress to = new MailAddress(curModel.Email);
                    MailMessage message = new MailMessage();
                    message.ReplyToList.Add(visitorAddress);
                    message.From = from;
                    message.To.Add(to);
                    message.Subject = subject;
                    message.IsBodyHtml = true;
                    message.Body = body;
                    message.BodyEncoding = Encoding.UTF8;
                    MbCommon.SendEmail(message);
                    return View("Success");
                }
                else if (model != null &&
                         model.CurrentPage != null)
                {
                    PageManager pageManager = new PageManager();
                    model.CurrentPage = pageManager.GetPage(model.CurrentPage.PageId);
                }
            }
            catch (Exception ex)
            {
                ModelState.AddModelError("", ex.Message);
            }
            return View(model);
        }
    }
}
