﻿using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;
using System.ComponentModel;

namespace mobx.mobi.Models
{
    public class InstallModel
    {
        [DisplayName("Admin email")]
        [DataType(DataType.EmailAddress)]
        [Required(ErrorMessage = "Email is required")]
        public string AdminEmail { get; set; }

        [DisplayName("Admin password")]
        [DataType(DataType.Password)]
        [Required(ErrorMessage = "Password is required")]
        public string AdminPassword { get; set; }

        [DisplayName("Admin password")]
        [DataType(DataType.Password)]
        [Required(ErrorMessage = "Confirm password is required")]
        [Compare("AdminPassword", ErrorMessage = "The passwords do not match.")]
        public string ConfirmPassword { get; set; }

        [AllowHtml]
        public string DatabaseConnectionString { get; set; }
        
        public string DataProvider { get; set; }

        #region SQL Server properties

        public string SqlConnectionInfo { get; set; }
        
        [AllowHtml]
        public string SqlServerName { get; set; }
        
        [AllowHtml]
        public string SqlDatabaseName { get; set; }
        
        [AllowHtml]
        public string SqlServerUsername { get; set; }
        
        [AllowHtml]
        public string SqlServerPassword { get; set; }
        
        public string SqlAuthenticationType { get; set; }
        
        [DisplayName("Create database if it doesn't exist")]
        public bool SqlServerCreateDatabase { get; set; }

        [DisplayName("Create sample data")]
        public bool InstallSampleData { get; set; }

        #endregion
    }
}